/*---------------------------------------------------------------------------
  Project:  ImageDb
  File:     JpegMpLoader.h
  
  SDJ[hɂJPEG/MPt@Cǂݍ݁AfR[hʂԂ܂B
  ---------------------------------------------------------------------------*/
#ifndef JPEG_MP_LOADER_H_
#define JPEG_MP_LOADER_H_


#include <nn/types.h>
#include <nn/util.h>
#include <nn/jpeg.h>
#include <imgdb/Core/ImageDbResult.h>


namespace imgdb {


/*!--------------------------------------------------------------------------*
  @brief JPEG/MPx[Xǂݍ݃NX
 *---------------------------------------------------------------------------*/
#pragma pack(push, 4)
class JpegMpBaseLoader
{
public:
    /*!----------------------------------------------------------------------
      @brief    RXgN^
      -----------------------------------------------------------------------*/
    JpegMpBaseLoader();

    /*!----------------------------------------------------------------------
      @brief    fXgN^
      -----------------------------------------------------------------------*/
    virtual ~JpegMpBaseLoader();


    /*=======================================================================
      Load()ĂяoOɐݒ肵Ă
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    WJ[U[[J[m[gi[obt@擾
      @return   obt@
      -----------------------------------------------------------------------*/
    void*           GetUserMakerNoteBuffer() const;
    /*!----------------------------------------------------------------------
      @brief    WJ[U[[J[m[gi[obt@̃TCY擾
      @return   obt@TCYioCgPʁj
      -----------------------------------------------------------------------*/
    std::size_t     GetUserMakerNoteBufferSize() const;
    /*!----------------------------------------------------------------------
      @brief    WJ[U[[J[m[gi[obt@ݒ肷
      @param[in]    pBuf    obt@
      @param[in]    nSize   obt@TCYioCgPʁj
      @details
      obt@̃AhX4oCgɃACgĂKv܂B
      -----------------------------------------------------------------------*/
    void    SetUserMakerNoteBuffer(void* pBuf, std::size_t nSize);


    /*=======================================================================
      Load()ĂяoɎ擾ł
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    fR[hBe擾
      @param[out]   rDateTime   Be
      @return   fR[hɐĂȂꍇfalse
      -----------------------------------------------------------------------*/
    bool    GetDateTime(nn::fnd::DateTime& rDateTime) const;

    /*-----------------------------------------------------------------------
      AvP[Vp̃[J[m[g
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    AvP[Vp̃[J[m[g̃f[^TCY擾
      @return   f[^TCYioCgPʁj
      @details
      fR[hɂo[J[m[g̎ۂ̃f[^TCYłB
      f[^̂SetUserMakerNoteBuffer()Ŏw肵obt@ɏ܂Ă܂B
      obt@ݒ肳ĂȂAݒ肳Ăobt@TCYs
      oȂꍇ̓[Ԃ܂B
      -----------------------------------------------------------------------*/
    std::size_t   GetUserMakerNoteDataSize() const;

    /*-----------------------------------------------------------------------
      VXe[J[m[g
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    VXe[J[m[g݂邩`FbN
      @return   ݂ꍇtrue
      -----------------------------------------------------------------------*/
    bool    IsExistSysMakerNote() const;

    /*!----------------------------------------------------------------------
      @brief    VXe[J[m[g̃f[^TCY擾
      @return   f[^TCYioCgPʁj
      -----------------------------------------------------------------------*/
    static std::size_t  GetSysMakerNoteDataSize();
    /*!----------------------------------------------------------------------
      @brief    VXe[J[m[g擾
      @return   VXe[J[m[g
      -----------------------------------------------------------------------*/
    const void*   GetSysMakerNoteData() const;

    /*-----------------------------------------------------------------------
      ^Cgj[NID
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    ^Cgj[NID擾
      @return   ^Cgj[NID
      @details
      ^Cgj[NIDƂ̓AvP[V20bit̃j[NIDłB
      -----------------------------------------------------------------------*/
    u32     GetTitleUniqueId() const;

    /*-----------------------------------------------------------------------
      
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    XN[VbgtO擾
      @retval   true    XN[Vbg̃f[^
      @retval   false   XN[VbgȊÕf[^
      -----------------------------------------------------------------------*/
    bool    GetScreenshotFlag() const;
    /*!----------------------------------------------------------------------
      @brief    œ_͈͕\tO擾
      @return   œ_͈͕\tO
      -----------------------------------------------------------------------*/
    bool    GetAdjustablePictureFlag() const;

    /*!----------------------------------------------------------------------
      @brief    炪܂܂Ăʐ^`FbN
      @return   炪܂܂ĂȂtrue
      -----------------------------------------------------------------------*/
    bool IsExistFace() const;

    /*-----------------------------------------------------------------------
      {ID
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    Be{IDL`FbN
      @return   Lȏꍇtrue
      -----------------------------------------------------------------------*/
    bool    IsValidShotBodyId() const;
    /*!----------------------------------------------------------------------
      @brief    Be{ID擾
      @return   Be{ID
      @details
      ȏꍇ̖߂l͕słB
      -----------------------------------------------------------------------*/
    u32     GetShotBodyId() const;

    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{IDL`FbN
      @return   Lȏꍇtrue
      -----------------------------------------------------------------------*/
    bool    IsValidEditorBodyId() const;
    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{ID擾
      @return   ŌɕҏW{ID
      @details
      ȏꍇ̖߂l͕słB
      -----------------------------------------------------------------------*/
    u32     GetEditorBodyId() const;


    /*=======================================================================
      ̑
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    摜̃TCY߂
      @param[in]    nWidth  摜̕isNZPʁj
      @param[in]    nHeight 摜̍isNZPʁj
      @param[in]    eFormat 摜̃sNZtH[}bg
      @return   摜TCYioCgPʁj
      -----------------------------------------------------------------------*/
    static std::size_t ComputeImageSize(
                        int nWidth, int nHeight, nn::jpeg::CTR::PixelFormat eFormat);

protected:
    void    SetDateTime(const nn::fnd::DateTime& rDateTime);
    void    ResetDateTime();

    bool    SetSysMakerNoteData(const void* pNote, std::size_t nSize);

    void    SetUserMakerNoteDataSize(std::size_t nSize);

    void    SetScreenshotFlag(bool bFlag);
    void    SetAdjustablePictureFlag(bool bFlag);

    void    SetShotBodyId(u32 nBodyId);
    void    ResetShotBodyId();

    void    SetEditorBodyId(u32 nBodyId);
    void    ResetEditorBodyId();

private:
    bool    GetHandleFlag(int nHandleType) const;
    void    SetHandleFlag(int nHandleType, bool bFlag);

    bool    IsValidBodyId(int nIdType) const;
    u32     GetBodyId(int nIdType) const;
    void    SetBodyId(int nIdType, u32 nBodyId);
    void    ResetBodyId(int nIdType);

private:
    void*               m_pUserMakerNoteBuf;
    std::size_t         m_pUserMakerNoteBufSize;
    nn::fnd::DateTime   m_nDateTime;
    bool                m_bValidDateTime;
    NN_PADDING3;
    std::size_t         m_nUserMakerNoteDataSize;
    void*               m_pSysMakerNoteData;
};
#pragma pack(pop)


/*!--------------------------------------------------------------------------*
  @brief JPEGǂݍ݃NX
  @details
  JPEGǂݍނɂ͍Œȉ̊֐ĂяoKv܂B<BR>
   SetFilePath()<BR>
   SetBuffer()<BR>
   SetFormat()<BR>
   Load()
 *---------------------------------------------------------------------------*/
class JpegLoader : public JpegMpBaseLoader, private nn::util::NonCopyable<JpegLoader>
{
public:
    //! WJ摜̃sNZtH[}bg̃ftHgl
    static const nn::jpeg::CTR::PixelFormat c_eDefaultRawFormat = nn::jpeg::CTR::PIXEL_FORMAT_CTR_RGB565;
    //! TlCǂݍ݃[h̃ftHgl
    static const bool                       c_nDefaultThumbnailMode = false;
    //! WJ摜i[obt@̃̕ftHgl
    static const int                        c_nDefaultOutputWidth = 0;

public:
    /*!----------------------------------------------------------------------
      @brief    RXgN^
      -----------------------------------------------------------------------*/
    JpegLoader();

    /*!----------------------------------------------------------------------
      @brief    fXgN^
      -----------------------------------------------------------------------*/
    virtual ~JpegLoader();

    /*!----------------------------------------------------------------------
      @brief    JPEGt@Cǂݍ
      @return   
      @details
      ݂̐ݒ肳ĂeJPEG摜ǂݍœWJ܂B<BR>
      ĂяoOɊeݒsĂĂB<BR>
      ݒ肪sꍇResultErrorInvalidParamԂĂ܂B<BR>

      {֐͎sɁA摜̍őTCY(400KB) + 10KB ̃ꎞ
      Iɏ܂B
      -----------------------------------------------------------------------*/
    Result  Load();


    /*=======================================================================
      Load()ĂяoOɐݒ肵Ă
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    ǂݍJPEGt@C̃pX擾
      @return   t@CpX
      -----------------------------------------------------------------------*/
    const wchar_t*  GetFilePath() const;
    /*!----------------------------------------------------------------------
      @brief    ǂݍJPEGt@C̃pXݒ肷
      @param[in]    pPath   t@CpX
      @details
      pPathJpeg/MpSaverAʐ^IAvbgŎ擾pXw肵܂B<BR>
      ȊÕpXw肵ꍇ̓T|[gOƂȂ܂B
      -----------------------------------------------------------------------*/
    void    SetFilePath(const wchar_t* pPath);


    /*!----------------------------------------------------------------------
      @brief    WJ摜̃sNZtH[}bg擾
      @return   sNZtH[}bg
      -----------------------------------------------------------------------*/
    nn::jpeg::CTR::PixelFormat  GetFormat() const;
    /*!----------------------------------------------------------------------
      @brief    WJ摜̃sNZtH[}bgݒ肷
      @param[in]    eFormat sNZtH[}bg
      -----------------------------------------------------------------------*/
    void    SetFormat(nn::jpeg::CTR::PixelFormat eFormat);


    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@̕擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetOutputWidth();
    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@̕ݒ肷
      @param[in]    nWidth  isNZPʁj
      @details
      ̓̕fR[h̃obt@̉w肷̂ŁA̒lw肷邱
      ŁAႦ64~64̉摜256~256̃obt@̍ɓWJƂ
      \ɂȂ܂B̒l摜̕ꍇ́Arb`Ƌl܂
      Ԃŉ摜fR[h܂B
      -----------------------------------------------------------------------*/
    void    SetOutputWidth(int nWidth);


    /*!----------------------------------------------------------------------
      @brief    TlCǂݍ݃[hׂ
      @retval   true    TlCǂݍ݃[h
      @retval   false   摜ǂݍ݃[h
      -----------------------------------------------------------------------*/
    bool    IsThumbnailMode() const;
    /*!----------------------------------------------------------------------
      @brief    TlCǂݍ݃[hݒ肷
      @param[in]    bThumbMode  TlCǂݍ݃[h
      @details
      bThumbModetruew肷ƁALoad()ɃTlC摜ǂݍ܂܂B
      -----------------------------------------------------------------------*/
    void    SetThumbnailMode(bool bThumbMode);


    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@擾
      @return   obt@
      -----------------------------------------------------------------------*/
    void*           GetBuffer() const;
    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@̃TCY擾
      @return   obt@TCYioCgPʁj
      -----------------------------------------------------------------------*/
    std::size_t     GetBufferSize() const;
    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@ݒ肷
      @param[in]    pBuf    obt@
      @param[in]    nSize   obt@TCYioCgPʁj
      @details
      obt@̃AhX4oCgɃACgĂKv܂B
      -----------------------------------------------------------------------*/
    void    SetBuffer(void* pBuf, std::size_t nSize);


    /*=======================================================================
      Load()ĂяoɎ擾ł
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    ǂݍ񂾉摜̕擾
      @return   isNZPʁj
      @details
      kfR[hꍇ͏k̕ƂȂ܂B
      -----------------------------------------------------------------------*/
    int     GetRawWidth() const;
    /*!----------------------------------------------------------------------
      @brief    ǂݍ񂾉摜̍擾
      @return   isNZPʁj
      @details
      kfR[hꍇ͏k̍ƂȂ܂B
      -----------------------------------------------------------------------*/
    int     GetRawHeight() const;
    /*!----------------------------------------------------------------------
      @brief    ǂݍ񂾉摜̃f[^TCY擾
      @return   f[^TCYioCgPʁj
      -----------------------------------------------------------------------*/
    std::size_t GetRawDataSize() const;

    /*!----------------------------------------------------------------------
      @brief    kfR[h̉e󂯂Ȃ摜̕擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRealWidth() const;
    /*!----------------------------------------------------------------------
      @brief    kfR[h̉e󂯂Ȃ摜̍擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRealHeight() const;

private:
    void    ResetLoaded();
    bool    IsLoaded() const;

    Result  ValidateParam() const;

private:
    const wchar_t*                  m_pFilePath;
    int                             m_nOutputWidth;
    nn::jpeg::CTR::PixelFormat      m_eFormat;
    bool                            m_bThumbMode;
    NN_PADDING2;

    void*           m_pBuf;
    std::size_t     m_nBufSize;

    int             m_nRawWidth;
    int             m_nRawHeight;
    std::size_t     m_nRawDataSize;
    int             m_nRealWidth;
    int             m_nRealHeight;
};


/*!--------------------------------------------------------------------------*
  @brief MPǂݍ݃NX
  @details
  MPǂݍނɂ͍Œȉ̊֐ĂяoKv܂B<BR>
   SetFilePath()<BR>
   SetBuffer()<BR>
   SetFormat()<BR>
   Load()<BR>
  
  ̉摜Ƃĕ\ہAʏ GetOffsetH() ̒lɉĉ摜Eɂ
  ĕ\ĂB
 *---------------------------------------------------------------------------*/
class MpLoader : public JpegMpBaseLoader, private nn::util::NonCopyable<MpLoader>
{
public:
    //! WJ摜̃sNZtH[}bg̃ftHgl
    static const nn::jpeg::CTR::PixelFormat c_eDefaultRawFormat = nn::jpeg::CTR::PIXEL_FORMAT_CTR_RGB565;
    //! TlCǂݍ݃[h̃ftHgl
    static const bool                       c_nDefaultThumbnailMode = false;
    //! WJ摜i[obt@̃̕ftHgl
    static const int                        c_nDefaultOutputWidth = 0;

public:
    /*!----------------------------------------------------------------------
      @brief    RXgN^
      -----------------------------------------------------------------------*/
    MpLoader();
    /*!----------------------------------------------------------------------
      @brief    fXgN^
      -----------------------------------------------------------------------*/
    virtual ~MpLoader();


    /*!----------------------------------------------------------------------
      @brief    MPt@Cǂݍ
      @return   
      @details
      ݂̐ݒ肳ĂeMP摜ǂݍœWJ܂B<BR>
      ĂяoOɊeݒsĂĂB<BR>
      ݒ肪sꍇResultErrorInvalidParamԂĂ܂B<BR>

      {֐͎sɁA摜̍őTCY(400KB) + 10KB ̃ꎞ
      Iɏ܂B
      -----------------------------------------------------------------------*/
    Result  Load();


    /*=======================================================================
      Load()ĂяoOɐݒ肵Ă
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    ǂݍMPt@C̃pX擾
      @return   t@CpX
      -----------------------------------------------------------------------*/
    const wchar_t*  GetFilePath() const;
    /*!----------------------------------------------------------------------
      @brief    ǂݍMPt@C̃pXݒ肷
      @param[in]    pPath   t@CpX
      @details
      pPathJpeg/MpSaverAʐ^IAvbgŎ擾pXw肵܂B<BR>
      ȊÕpXw肵ꍇ̓T|[gOƂȂ܂B
      -----------------------------------------------------------------------*/
    void    SetFilePath(const wchar_t* pPath);


    /*!----------------------------------------------------------------------
      @brief    WJ摜̃sNZtH[}bg擾
      @return   sNZtH[}bg
      -----------------------------------------------------------------------*/
    nn::jpeg::CTR::PixelFormat  GetFormat() const;
    /*!----------------------------------------------------------------------
      @brief    WJ摜̃sNZtH[}bgݒ肷
      @param[in]    eFormat sNZtH[}bg
      -----------------------------------------------------------------------*/
    void    SetFormat(nn::jpeg::CTR::PixelFormat eFormat);


    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@̕擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetOutputWidth();
    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@̕ݒ肷
      @param[in]    nWidth  isNZPʁj
      @details
      ̓̕fR[h̃obt@̉w肷̂ŁA̒lw肷邱
      ŁAႦ64~64̉摜256~256̃obt@̍ɓWJƂ
      \ɂȂ܂B̒l摜̕ꍇ́Arb`Ƌl܂
      Ԃŉ摜fR[h܂B
      -----------------------------------------------------------------------*/
    void    SetOutputWidth(int nWidth);


    /*!----------------------------------------------------------------------
      @brief    TlCǂݍ݃[hׂ
      @retval   true    TlCǂݍ݃[h
      @retval   false   摜ǂݍ݃[h
      -----------------------------------------------------------------------*/
    bool    IsThumbnailMode() const;
    /*!----------------------------------------------------------------------
      @brief    TlCǂݍ݃[hݒ肷
      @param[in]    bThumbMode  TlCǂݍ݃[h
      @details
      bThumbModetruew肷ƁALoad()ɃTlC摜ǂݍ܂܂B
      -----------------------------------------------------------------------*/
    void    SetThumbnailMode(bool bThumbMode);


    /*!----------------------------------------------------------------------
      @brief    WJ̉摜i[obt@擾
      @return   obt@
      -----------------------------------------------------------------------*/
    void*           GetBufferL();
    /*!----------------------------------------------------------------------
      @brief    WJẺ摜i[obt@擾
      @return   obt@
      -----------------------------------------------------------------------*/
    void*           GetBufferR();
    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@̃TCY擾
      @return   obt@TCYioCgPʁj
      -----------------------------------------------------------------------*/
    std::size_t     GetBufferSize() const;
    /*!----------------------------------------------------------------------
      @brief    WJ摜i[obt@ݒ肷
      @param[in]    pBufL   ̃obt@iksj
      @param[in]    pBufR   Ẽobt@ikj
      @param[in]    nSize   obt@TCYioCgPʁj
      @details
      obt@̃AhX4oCgɃACgĂKv܂B<BR>
      pBufRɃkw肷邱ƂŁẢ摜擾邱Ƃo܂B<BR>
      TlC摜pBufRɂ̉摜i[܂B
      -----------------------------------------------------------------------*/
    void    SetBuffer(void* pBufL, void* pBufR, std::size_t nSize);


    /*=======================================================================
      Load()ĂяoɎ擾ł
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    ǂݍ񂾉摜̕擾
      @return   isNZPʁj
      @details
      kfR[hꍇ͏k̕ƂȂ܂B
      -----------------------------------------------------------------------*/
    int     GetRawWidth() const;
    /*!----------------------------------------------------------------------
      @brief    ǂݍ񂾉摜̍擾
      @return   isNZPʁj
      @details
      kfR[hꍇ͏k̍ƂȂ܂B
      -----------------------------------------------------------------------*/
    int     GetRawHeight() const;
    /*!----------------------------------------------------------------------
      @brief    ǂݍ񂾉摜̃f[^TCY擾
      @return   f[^TCYioCgPʁj
      -----------------------------------------------------------------------*/
    std::size_t GetRawDataSize() const;

    /*!----------------------------------------------------------------------
      @brief    kfR[h̉e󂯂Ȃ摜̕擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRealWidth() const;
    /*!----------------------------------------------------------------------
      @brief    kfR[h̉e󂯂Ȃ摜̍擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRealHeight() const;

    /*!----------------------------------------------------------------------
      @brief    ItZbgl擾
      @return   ItZbglisNZPʁj
      @details
      l 0.0f ͍̎ƉẺ摜𓯂ʒuɕ\܂B<BR>
      l 1.0f ̎ 摜ɁikfR[h̉e󂯂Ȃ摜̕
      ΂āj1sNZAE摜E1sNZړĕ\܂B<BR>
      ʏ̕\ʒu͕\傫ɍ킹XP[悤ɂĂ
      B<BR>
      ̒l GetAdjustablePictureFlag()  true ԂƂ̂ݎgpAfalse 
      ̂Ƃ 0.0f ƂĈĂB
      -----------------------------------------------------------------------*/
    f32     GetOffsetH() const;

private:
    void    ResetLoaded();
    bool    IsLoaded() const;

    Result  ValidateParam() const;

private:
    const wchar_t*                  m_pFilePath;
    int                             m_nOutputWidth;
    nn::jpeg::CTR::PixelFormat      m_eFormat;
    bool                            m_bThumbMode;
    NN_PADDING2;

    void*           m_pBufL;
    void*           m_pBufR;
    std::size_t     m_nBufSize;

    int             m_nRawWidth;
    int             m_nRawHeight;
    std::size_t     m_nRawDataSize;
    int             m_nRealWidth;
    int             m_nRealHeight;
    f32             m_fOfstH;
};


} // end of namespace imgdb

#endif // JPEG_MP_LOADER_H_
