/*---------------------------------------------------------------------------
  Project:  ImageDb
  File:     JpegMpSaver.h
  
  摜f[^󂯎ƁAJPEG/MPɃGR[hASDJ[h֕ۑ܂B
  ۑꂽ摜̓jeh[3DSJŊǗ܂B
  ---------------------------------------------------------------------------*/
#ifndef JPEG_MP_SAVER_H_
#define JPEG_MP_SAVER_H_

#include <nn/types.h>
#include <nn/util.h>
#include <nn/jpeg.h>
#include <imgdb/ImageIO/ImageIOTypes.h>
#include <imgdb/Core/ImageDbResult.h>


namespace imgdb {


/*!--------------------------------------------------------------------------*
  @brief JPEG/MPx[XۑNX
 *---------------------------------------------------------------------------*/
class JpegMpBaseSaver
{
public:
    //! XN[VbgtÕftHgl
    static const bool               c_bDefaultScreenshotFlag = false;
    //! œ_͈͕\tÕftHgl
    static const bool               c_bDefaultAdjustablePictureFlag = false;
    //! Ȗ{ID
    static const u32                c_nInvalidId = 0;
    //! Be{ID̗LԂ̃ftHgl
    static const bool               c_bDefaultValidShotId = true;
    //! ŌɕҏW{ID̗LԂ̃ftHgl
    static const bool               c_bDefaultValidEditorId = false;

public:
    /*!----------------------------------------------------------------------
      @brief    RXgN^
      -----------------------------------------------------------------------*/
    JpegMpBaseSaver();
    /*!----------------------------------------------------------------------
      @brief    fXgN^
      -----------------------------------------------------------------------*/
    virtual ~JpegMpBaseSaver();


    /*=======================================================================
      Save()ĂяoOɐݒ肵Ă
      =======================================================================*/
    /*-----------------------------------------------------------------------
      AvP[Vp̃[J[m[g
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    AvP[Vp̃[J[m[g̃f[^擾
      @return   f[^
      @details
      ݒ肳ĂȂꍇ̓kԂ܂B
      -----------------------------------------------------------------------*/
    const void*   GetUserMakerNoteData() const;
    /*!----------------------------------------------------------------------
      @brief    AvP[Vp̃[J[m[g̃f[^TCY擾
      @return   f[^TCYioCgPʁj
      @details
      ݒ肳ĂȂꍇ̓[Ԃ܂B
      -----------------------------------------------------------------------*/
    std::size_t   GetUserMakerNoteDataSize() const;
    /*!----------------------------------------------------------------------
      @brief    AvP[Vp̃[J[m[gݒ肷
      @param[in]    pData   f[^
      @param[in]    nSize   f[^TCYioCgPʁj
      @details
      pDataɃkA܂nSizeɃ[w肷Ɩݒ̏ԂɂȂ܂B
      -----------------------------------------------------------------------*/
    void    SetUserMakerNote(const void* pData, std::size_t nSize);

    /*-----------------------------------------------------------------------
      VXe[J[m[g
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    VXe[J[m[g̃f[^TCY擾
      @return   f[^TCYioCgPʁj
      -----------------------------------------------------------------------*/
    static std::size_t  GetSysMakerNoteDataSize();
    /*!----------------------------------------------------------------------
      @brief    VXe[J[m[g擾
      @return   VXe[J[m[g
      -----------------------------------------------------------------------*/
    const void*   GetSysMakerNoteData() const;
    /*!----------------------------------------------------------------------
      @brief    VXe[J[m[gݒ肷
      @param[in]    pNote   VXe[J[m[g
      @param[in]    nSize   VXe[J[m[g̃f[^TCY
      @return   ݒɐꍇtrue
      @details
      ^Cgj[NIDetOȂǁAݒ肳ꂽׂ͂Ďw肳ꂽ
      VXe[J[m[g̒lɏ㏑܂B
      -----------------------------------------------------------------------*/
    bool    SetSysMakerNoteData(const void* pNote, std::size_t nSize);


    /*-----------------------------------------------------------------------
      ^Cgj[NID
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    ^Cgj[NID擾
      @return  ^Cgj[NID
      @details
      ^Cgj[NIDƂ̓AvP[V20bit̃j[NIDłB
      -----------------------------------------------------------------------*/
    u32     GetTitleUniqueId() const;
    /*!----------------------------------------------------------------------
      @brief    ^Cgj[NIDݒ肷
      @param[in]    nUId   ^Cgj[NID
      @return   ݒɐꍇtrue
      @details
      ^Cgj[NIDƂ̓AvP[V20bit̃j[NIDłB
      -----------------------------------------------------------------------*/
    void    SetTitleUniqueId(u32 nUId);

    /*-----------------------------------------------------------------------
      
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    XN[VbgtO擾
      @retval   true    XN[Vbg̃f[^
      @retval   false   XN[VbgȊÕf[^
      -----------------------------------------------------------------------*/
    bool    GetScreenshotFlag() const;
    /*!----------------------------------------------------------------------
      @brief    XN[VbgtOݒ肷
      @param[in]    bFlag   XN[VbgtO
      @details
      XN[Vbĝ߂̃tOłB
      -----------------------------------------------------------------------*/
    void    SetScreenshotFlag(bool bFlag);

    /*!----------------------------------------------------------------------
      @brief    œ_͈͕\tO擾
      @return   œ_͈͕\tO
      -----------------------------------------------------------------------*/
    bool    GetAdjustablePictureFlag() const;
    /*!----------------------------------------------------------------------
      @brief    œ_͈͕\tOݒ肷
      @param[in]    bFlag   œ_͈͕\tO
      @details
      ̃tOĂ摜́Ajeh[3DSJ̃uEYŕ\
      ƂAɏœ_ł͈͂\܂iʉ摜ł\
      ͈͓͂jB<BR>
      摜TCY 400x240`1024x768 ̏ꍇ̂ݐݒł܂B<BR>
      ̃tOĂȂ摜́A摜̑ŜULCDʂ̒Ɏ܂悤
      \Aœ_͂ł܂B
      -----------------------------------------------------------------------*/
    void    SetAdjustablePictureFlag(bool bFlag);

    /*-----------------------------------------------------------------------
      {ID
      -----------------------------------------------------------------------*/
    /*!----------------------------------------------------------------------
      @brief    Be{IDL`FbN
      @return   Lȏꍇtrue
      -----------------------------------------------------------------------*/
    bool    IsValidShotBodyId() const;
    /*!----------------------------------------------------------------------
      @brief    Be{ID擾
      @return   Be{ID
      @details
      ȏꍇ̖߂l͕słB
      ftHgłCTR̖{IDݒ肳Ă܂B
      -----------------------------------------------------------------------*/
    u32     GetShotBodyId() const;
    /*!----------------------------------------------------------------------
      @brief    Be{IDݒ肷
      @param[in]    nBodyId     {ID
      @details
      ̉摜̏ꍇ́Ả摜Ɋ܂܂Be{IDw肵ĂB
      -----------------------------------------------------------------------*/
    void    SetShotBodyId(u32 nBodyId);
    /*!----------------------------------------------------------------------
      @brief    Be{ID̖{IDɐݒ肷
      @details
      ̉摜̏ꍇ́Ả摜Ɋ܂܂Be{IDASetShotBodyId()
      w肵ĂB
      -----------------------------------------------------------------------*/
    void    SetShotBodyIdByOwn();
    /*!----------------------------------------------------------------------
      @brief    Be{ID𖳌ԂɃZbg
      -----------------------------------------------------------------------*/
    void    ResetShotBodyId();

    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{IDL`FbN
      @return   Lȏꍇtrue
      -----------------------------------------------------------------------*/
    bool    IsValidEditorBodyId() const;
    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{ID擾
      @return   ŌɕҏW{ID
      @details
      ȏꍇ̖߂l͕słB
      -----------------------------------------------------------------------*/
    u32     GetEditorBodyId() const;
    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{IDݒ肷
      @param[in]    nBodyId     {ID
      @details
      ̉摜HȂǂsĕۑꍇ́ACTR̖{IDw肷邩A
      SetEditorBodyIdByOwn()ŐݒsĂB
      ̂ق̏ꍇ͏lẢ摜IDw肵ĂB
      -----------------------------------------------------------------------*/
    void    SetEditorBodyId(u32 nBodyId);
    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{ID̖{IDɐݒ肷
      @details
      ̉摜̏ꍇ́Ả摜Ɋ܂܂ŌɕҏW{IDA
      SetEditorBodyId()Ŏw肵ĂB
      -----------------------------------------------------------------------*/
    void    SetEditorBodyIdByOwn();
    /*!----------------------------------------------------------------------
      @brief    ŌɕҏW{ID𖳌ԂɃZbg
      -----------------------------------------------------------------------*/
    void    ResetEditorBodyId();

protected:
    bool    IsValidTitleUniqueId() const;

    bool    GetHandleFlag(int nHandleType) const;
    void    SetHandleFlag(int nHandleType, bool bFlag);

    bool    IsValidBodyId(int nIdType) const;
    u32     GetBodyId(int nIdType) const;
    void    SetBodyId(int nIdType, u32 nBodyId);
    void    ResetBodyId(int nIdType);

protected:
    const void* m_pUserMakerNoteData;
    std::size_t m_nUserMakerNoteDataSize;
    void*       m_pSysMakerNoteData;
    bool        m_bValidTitleUniqueId;
    NN_PADDING3;
};


/*!--------------------------------------------------------------------------*
  @brief JPEGۑNX
  @details
  JPEGۑɂ͍Œȉ̊֐ĂяoKv܂B<BR>
   SetRaw()<BR>
   SetTitleUniqueId()<BR>
   Save()
 *---------------------------------------------------------------------------*/
class JpegSaver : public JpegMpBaseSaver, private nn::util::NonCopyable<JpegSaver>
{
public:
    //! ftHgJPEGi̎LtO
    static const bool   c_bEnableQualityAutoAbatementFlag = true;
    //! JPEG̕ĩftHgl
    static const int                c_nDefaultJpegQuality = 80;
    //! JPEG̃TvOtH[}bg̃ftHgl
    static const nn::jpeg::CTR::PixelSampling  c_eDefaultJpegFormat = nn::jpeg::CTR::PIXEL_SAMPLING_YUV422;

public:
    /*!----------------------------------------------------------------------
      @brief    RXgN^
      -----------------------------------------------------------------------*/
    JpegSaver();
    /*!----------------------------------------------------------------------
      @brief    fXgN^
      -----------------------------------------------------------------------*/
    virtual ~JpegSaver();

    /*!----------------------------------------------------------------------
      @brief    JPEGt@CƂĕۑ
      @return   
      @details
      ݂̐ݒ肳Ăeŉ摜JPEGɕϊĕۑ܂B<BR>
      ĂяoOɊeݒsĂĂB<BR>
      ݒ肪sꍇResultErrorInvalidParamԂĂ܂B<BR>

      {֐͎sɁAJPEG̃TCY(`200KB) + 35KB ̃ꎞIɏ
      ܂B
      -----------------------------------------------------------------------*/
    Result  Save();


    /*=======================================================================
      Save()ĂяoOɐݒ肵Ă
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    JPEGi̎LtO擾
      @return   JPEGi̓LtO
      -----------------------------------------------------------------------*/
    bool    GetEnableQualityAutoAbatementFlag() const;
    /*!----------------------------------------------------------------------
      @brief    JPEGi̎LtOݒ肷
      @param[in]    bEnable     JPEGi̎LtO
      @details
      LɂƁAGR[h摜KTCYI[o[ꍇA
      ŕičēxGR[hs܂B<BR>
      i͐ݒ肳ꂽl10Ē܂B<BR>
      ɂƃTCYI[o[ResultErrorTooLargeFileG[ƂȂ܂B
      -----------------------------------------------------------------------*/
    void    SetEnableQualityAutoAbatementFlag(bool bEnable);

    /*!----------------------------------------------------------------------
      @brief    JPEG̕i擾
      @return   i [1, 100]
      -----------------------------------------------------------------------*/
    int     GetJpegQuality() const;
    /*!----------------------------------------------------------------------
      @brief    JPEG̕iݒ肷
      @param[in]    nQuality    i [1, 100]
      -----------------------------------------------------------------------*/
    void    SetJpegQuality(int nQuality);

    /*!----------------------------------------------------------------------
      @brief    JPEG̃TvOtH[}bg擾
      @return   TvOtH[}bg
      -----------------------------------------------------------------------*/
    nn::jpeg::CTR::PixelSampling   GetJpegFormat() const;
    /*!----------------------------------------------------------------------
      @brief    JPEG̃TvOtH[}bgݒ肷
      @param[in]    eFormat TvOtH[}bg
      -----------------------------------------------------------------------*/
    void    SetJpegFormat(nn::jpeg::CTR::PixelSampling eFormat);

    /*!----------------------------------------------------------------------
      @brief    ۑ摜f[^擾
      @return   摜f[^
      -----------------------------------------------------------------------*/
    const void* GetRawData() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜̕擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRawWidth() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜̍擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRawHeight() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜̃sNZtH[}bg擾
      @return   sNZtH[}bg
      -----------------------------------------------------------------------*/
    nn::jpeg::CTR::PixelFormat  GetRawFormat() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜ݒ肷
      @param[in]    pData   摜f[^
      @param[in]    nWidth  摜̕isNZPʁj
      @param[in]    nHeight 摜̍isNZPʁj
      @param[in]    eFormat 摜̃sNZtH[}bg
      -----------------------------------------------------------------------*/
    void    SetRaw(
                const void* pData, int nWidth, int nHeight,
                nn::jpeg::CTR::PixelFormat eFormat);


    /*=======================================================================
      Save()ĂяoɎ擾ł
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    ۑJPEG̃t@CpX擾
      @return   t@CpX
      @details
      ۑĂȂAoȂꍇȂǂ͋󕶎Ԃ܂B
      -----------------------------------------------------------------------*/
    const wchar_t*  GetSavedFilePath() const;

private:
    Result  ValidateParam() const;
    void    SetFilePathToVirtual(const wchar_t* pPath);

private:
    int                             m_nJpegQuality;
    nn::jpeg::CTR::PixelSampling    m_eJpegFormat;
    bool                            m_bEnableQualityAutoAbatementFlag;
    NN_PADDING2;

    const void*                 m_pRawData;
    int                         m_nRawWidth;
    int                         m_nRawHeight;
    nn::jpeg::CTR::PixelFormat  m_eRawFormat;
    NN_PADDING3;
    wchar_t*                    m_pFilePath;
};


/*!--------------------------------------------------------------------------*
  @brief MPۑNX
  @details
  MPۑɂ͍Œȉ̊֐ĂяoKv܂B<BR>
   SetRaw()<BR>
   SetTitleUniqueId()<BR>
   Save()
 *---------------------------------------------------------------------------*/
class MpSaver : public JpegMpBaseSaver, private nn::util::NonCopyable<MpSaver>
{
public:
    //! ftHgJPEGi̎LtO
    static const bool   c_bEnableQualityAutoAbatementFlag = true;
    //! JPEG̕ĩftHgl
    static const int                c_nDefaultJpegQuality = 80;
    //! JPEG̃TvOtH[}bg̃ftHgl
    static const nn::jpeg::CTR::PixelSampling  c_eDefaultJpegFormat = nn::jpeg::CTR::PIXEL_SAMPLING_YUV422;

public:
    /*!----------------------------------------------------------------------
      @brief    RXgN^
      -----------------------------------------------------------------------*/
    MpSaver();
    /*!----------------------------------------------------------------------
      @brief    fXgN^
      -----------------------------------------------------------------------*/
    virtual ~MpSaver();

    /*!----------------------------------------------------------------------
      @brief    MPt@CƂĕۑ
      @return   
      @details
      ݂̐ݒ肳Ăeŉ摜MPɕϊA΂ƂȂJPEGƂƂɕۑ
      ܂B<BR>
      JPEGƂĕۑ摜́Ả摜f[^gp܂B<BR>
      ĂяoOɊeݒsĂĂB<BR>
      ݒ肪sꍇResultErrorInvalidParamԂ܂B<BR>

      {֐͎sɁAMP̃TCY(`400KB) + JPEG̃TCY(`400KB) + 10KB 
      ̃ꎞIɏ܂B<BR>
      ʏAJPEG̃TCYMPt@C̔ɂȂ邽߁A600KB ̃g
      p邱ƂɂȂ܂Aő 810KB gpꍇ܂B
      -----------------------------------------------------------------------*/
    Result  Save();


    /*=======================================================================
      Save()ĂяoOɐݒ肵Ă
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    JPEGi̎LtO擾
      @return   JPEGi̓LtO
      -----------------------------------------------------------------------*/
    bool    GetEnableQualityAutoAbatementFlag() const;
    /*!----------------------------------------------------------------------
      @brief    JPEGi̎LtOݒ肷
      @param[in]    bEnable     JPEGi̎LtO
      @details
      LɂƁAGR[h摜KTCYI[o[ꍇA
      ŕičēxGR[hs܂B<BR>
      i͂Pڂ̉摜ŋKTCYI[o[ꍇ͔A
      킹ăI[o[ꍇ10Ē܂B<BR>
      ɂƃTCYI[o[ResultErrorTooLargeFileG[ƂȂ܂B
      -----------------------------------------------------------------------*/
    void    SetEnableQualityAutoAbatementFlag(bool bEnable);

    /*!----------------------------------------------------------------------
      @brief    JPEG̕i擾
      @return   i [1, 100]
      -----------------------------------------------------------------------*/
    int     GetJpegQuality() const;
    /*!----------------------------------------------------------------------
      @brief    JPEG̕iݒ肷
      @param[in]    nQuality    i [1, 100]
      -----------------------------------------------------------------------*/
    void    SetJpegQuality(int nQuality);

    /*!----------------------------------------------------------------------
      @brief    JPEG̃TvOtH[}bg擾
      @return   TvOtH[}bg
      -----------------------------------------------------------------------*/
    nn::jpeg::CTR::PixelSampling   GetJpegFormat() const;
    /*!----------------------------------------------------------------------
      @brief    JPEG̃TvOtH[}bgݒ肷
      @param[in]    eFormat TvOtH[}bg
      -----------------------------------------------------------------------*/
    void    SetJpegFormat(nn::jpeg::CTR::PixelSampling eFormat);

    /*!----------------------------------------------------------------------
      @brief    ۑ鍶̉摜f[^擾
      @return   摜f[^
      -----------------------------------------------------------------------*/
    const void* GetRawDataL() const;
    /*!----------------------------------------------------------------------
      @brief    ۑẺ摜f[^擾
      @return   摜f[^
      -----------------------------------------------------------------------*/
    const void* GetRawDataR() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜̕擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRawWidth() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜̍擾
      @return   isNZPʁj
      -----------------------------------------------------------------------*/
    int     GetRawHeight() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜̃sNZtH[}bg擾
      @return   sNZtH[}bg
      -----------------------------------------------------------------------*/
    nn::jpeg::CTR::PixelFormat  GetRawFormat() const;
    /*!----------------------------------------------------------------------
      @brief    ۑ摜ݒ肷
      @param[in]    pDataL  ̉摜f[^
      @param[in]    pDataR  Ẻ摜f[^
      @param[in]    nWidth  摜̕isNZPʁj
      @param[in]    nHeight 摜̍isNZPʁj
      @param[in]    eFormat 摜̃sNZtH[}bg
      -----------------------------------------------------------------------*/
    void    SetRaw(
                const void* pDataL, const void* pDataR,
                int nWidth, int nHeight, nn::jpeg::CTR::PixelFormat eFormat);

    /*!----------------------------------------------------------------------
      @brief    ItZbgl擾
      @return   ItZbglisNZPʁj
      -----------------------------------------------------------------------*/
    f32     GetOffsetH() const;
    /*!----------------------------------------------------------------------
      @brief    ItZbglݒ肷
      @param[in]    fOfstH  ItZbglisNZPʁj
      -----------------------------------------------------------------------*/
    void    SetOffsetH(f32 fOfstH);


    /*=======================================================================
      Save()ĂяoɎ擾ł
      =======================================================================*/
    /*!----------------------------------------------------------------------
      @brief    ۑMP̃t@CpX擾
      @return   t@CpX
      @details
      ۑĂȂAoȂꍇȂǂ͋󕶎Ԃ܂B
      -----------------------------------------------------------------------*/
    const wchar_t*  GetSavedFilePath() const;

private:
    Result  ValidateParam() const;
    void    SetFilePathToVirtual(const wchar_t* pPath);

private:
    int                             m_nJpegQuality;
    nn::jpeg::CTR::PixelSampling    m_eJpegFormat;
    bool                            m_bEnableQualityAutoAbatementFlag;
    NN_PADDING2;

    const void*                 m_pRawDataL;
    const void*                 m_pRawDataR;
    int                         m_nRawWidth;
    int                         m_nRawHeight;
    nn::jpeg::CTR::PixelFormat  m_eRawFormat;
    NN_PADDING3;
    f32                         m_fOfstH;
    wchar_t*                    m_pFilePath;
};



} // end of namespace imgdb

#endif // JPEG_MP_SAVER_H_
